<?php
/***************************************************************************

           TPLN  by HAYOUN Laurent

           website: http://tpln.sourceforge.net
           email: php_work@hotmail.com

****************************************************************************/
/*
<docgeny>
<menu name="showrecords">
 <name lang="fr">La fonction ShowRecords</name>
 <name lang="en">ShowRecords function</name>

 <function>void ShowRecords(string query, int result_by_page=0)</function>


 <description lang="fr">
 La fonction <b>ShowRecords()</b> est une fonction qui permet de parser les donnes
provenant de votre base donnes automatiquement, vous n'avez qu' crer votre
template et la fonction s'occupe de tout pour vous !
<br>
<br>
Votre template doit tre configurer comme ceci :
<ul>
  <li><b><font color="#009966">&lt;bloc::data&gt;</font></b></li>
  <li> <b><font color="#FF9900">&nbsp;&nbsp;&nbsp;&nbsp;&lt;bloc::loop&gt;&lt;/bloc::loop&gt;</font></b>
    contient le nom de vos champs en variable</li>
  <li> <b><font color="#FF3333">&nbsp;&nbsp;&nbsp;&nbsp;&lt;bloc::norecord&gt;&lt;/bloc::norecord&gt;</font></b>
    contient le message s'il n'y a pas de rsultats</li>
  <li><b><font color="#009966">&lt;/bloc::data&gt;</font></b></li>
</ul>
 <br>
Cette fonction possde ses variables propritaires qui sont parses automatiquement
celles ci doivent tre prsentes dans le bloc <b><font color="#009966">&lt;bloc::data&gt;&lt;/bloc::data&gt;</font></b>
elles sont notes comme ceci <b>{_Variable}</b>.
<ul>
  <li><b><font color="#0000FF">_First</font></b> indique le num&eacute;ro du premier
    enregistrement de la page en cours</li>
  <li><b><font color="#0000FF">_Last</font></b> indique le num&eacute;ro du dernier
    enregistrement de la page en cours</li>
  <li><b><font color="#0000FF">_Count</font></b> indique le nombre de rsultats
  </li>
  <li><b><font color="#0000FF">_PageNumber</font></b> indique la page actuelle
  </li>
  <li><b><font color="#0000FF">_PageCount</font></b> indique le nombre de page
    total </li>
</ul>
Variables propritaires entre les balises <b><font color="#FF9900">&lt;bloc::loop&gt;&lt;/bloc::loop&gt;
</font></b>
<ul>
  <li><b><font color="#0000FF">_Id</font></b> indique le numro d'enregistrement
    gnr par TPLN</li>
  <li><b><font color="#0000FF">_NavColor</font></b> remplace par l'une des deux
    couleurs spcifies dans le fichier TPLN_Cfg.php ou par <a href="setnavcolor.html">SetNavColor()</a>
  </li>
</ul>
<p>TPLN g&eacute;n&egrave;re &eacute;galement pour vous les boutons de navigation
  (pagination incluse) , il faut les d&eacute;finir au sein de votre bloc <b><font color="#009966">&lt;bloc::data&gt;</font></b>
  sous forme de bloc, ceci sont personalisables puis qu'il font parti du template
  : </p>
<ul>
  <li><font color="#0000FF"><b>Pager</b></font> pour cr&eacute;er la pagination
    de r&eacute;sultats, ce bloc doit contenir deux sous blocs, <b><font color="#009966">&lt;bloc::in&gt;</font></b>
    et <b><font color="#009966">&lt;bloc::out&gt;</font></b></li>
  <br>
  <br>
  <li><b><font color="#009966">&lt;bloc::in&gt;</font></b> est g&eacute;n&eacute;r&eacute;
    pour personaliser la page en cours, ce bloc doit contenir la variable <b>{_Page}
    </b></li>
  <li><b><font color="#009966">&lt;bloc::out&gt;</font></b> est g&eacute;n&eacute;r&eacute;
    pour personaliser les pages differentes de la page en cours, ce bloc doit
    contenir la variable <b>{_Url} </b>et<b> {_Page} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::pager&gt;
  &lt;bloc::in&gt;&lt;font color=&quot;red&quot;&gt;{_Page}&lt;/font&gt;&lt;/bloc::in&gt;
  &lt;bloc::out&gt;&lt;a href=&quot;{_Url}&quot;&gt;{_Page}&lt;/a&gt;&lt;/bloc::out&gt;
&lt;/bloc::pager&gt;
</pre>
    </td>
  </tr>
</table>
<ul>
  <li> <b><font color="#0000FF">D&eacute;but</font></b> pour aller &agrave; la
    premi&egrave;re page de r&eacute;sultats, ce bloc doit contenir la variable
    <b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::start&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;bng.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::start&gt;
</pre>
    </td>
  </tr>
</table>
<ul>
  <li><font color="#0000FF"><b>Pr&eacute;c&eacute;dent</b></font> pour aller &agrave;
    la page des r&eacute;sultats pr&eacute;c&eacute;dente, ce bloc doit contenir
    la variable <b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::previous&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;prev.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::previous&gt;
</pre>
      </td>
  </tr>
</table>
<ul>
  <li><font color="#0000FF"><b>Suivant</b></font> pour aller &agrave; la page
    des r&eacute;sultats suivante, ce bloc doit contenir la variable <b>{_Url}
    </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::next&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;suiv.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::next&gt;
</pre>
    </td>
  </tr>
</table>
<ul>
  <li><font color="#0000FF"><b>Fin </b></font> pour aller &agrave; la derni&egrave;re
    page de r&eacute;sultats, ce bloc doit contenir la variable <b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::end&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;suiv.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::end&gt;
</pre>
    </td>
  </tr>
</table>
 </description>

 <description lang="en">
 The ShowRecords() function  is a function that permits to parse
 the data coming automatically from your database,
 you only have to create your template and the function takes care of all for you!
 <br>
 <br>
 Your template must be to configure as this:
 <ul>
  <li><b><font color="#009966">&lt;bloc::data&gt;</font></b></li>
  <li>  <b><font color="#FF9900">&nbsp;&nbsp;&nbsp;&nbsp;&lt;bloc::loop&gt;&lt;/bloc::loop&gt;</font></b> contains the name of your fields in variable </li>
  <li>  <b><font color="#FF3333">&nbsp;&nbsp;&nbsp;&nbsp;&lt;bloc::norecord&gt;&lt;/bloc::norecord&gt;</font></b> contains the message if there are not any results </ li>
  <li><b><font color="#009966">&lt;/bloc::data&gt;</font></b></li>
 </ul>

 This function possesses its variable owners who are automatically here parses
those must be present in the block <b><font color="#009966">&lt;bloc::data&gt;&lt;/bloc::data&gt;</font></b>
they are noted like this <b>{_Variable}</b>.
<ul>
  <li><b><font color="#0000FF">_First</font></b> indicates the position of the
    first record</ li>
  <li><b><font color="#0000FF">_Last</font></b> indicates the position of the
    last record </ li>
  <li><b><font color="#0000FF">_Count</font></b> indicates the number of results
    </ li>
  <li><b><font color="#0000FF">_PageNumber</font></b> indicates the present page
    </ li>
  <li><b><font color="#0000FF">_PageCount</font></b> indicates the number of total
    page </ li>
</ul>

 Variable owners between <b><font color="#FF9900">&lt;bloc::loop&gt;&lt;/bloc::loop&gt;</font></b><bloc::loop><bloc::loop>
<ul>
  <li><b><font color="#0000FF">_Id</font></b> indicates the number of registration
    generated by TPLN </li>
  <li><b><font color="#0000FF">_NavColor</font></b> replaces by one two colors
    specified in the TPLN_Cfg.php file or by <a href="setnavcolor.html">SetNavColor()</a></li>
</ul>
<p>TPLN generates for you nagigation buttons (pagination included), you have to
  define its inside your bloc <b><font color="#009966">&lt;bloc::data&gt;</font></b>
  as blocs, they are customizables: </p>
<ul>
  <li><font color="#0000FF"><b>Pager</b></font> to create results pagination,
    this bloc must countains 2 blocs, <b><font color="#009966">&lt;bloc::in&gt;</font></b>
    and<b><font color="#009966">&lt;bloc::out&gt;</font></b></li>
  <br>
  <br>
  <li><b><font color="#009966">&lt;bloc::in&gt;</font></b> is generated for the
    actual page of results, this bloc must countains the variable <b>{_Page} </b></li>
  <li><b><font color="#009966">&lt;bloc::out&gt;</font></b> is generated for the
    others pages of results, this bloc must countains the variable <b>{_Page}</b>
    et <b>{_Url}.</b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::pager&gt;
  &lt;bloc::in&gt;&lt;font color=&quot;red&quot;&gt;{_Page}&lt;/font&gt;&lt;/bloc::in&gt;
  &lt;bloc::out&gt;&lt;a href=&quot;{_Url}&quot;&gt;{_Page}&lt;/a&gt;&lt;/bloc::out&gt;
&lt;/bloc::pager&gt;
</pre>
    </td>
  </tr>
</table>
<ul>
  <li> <b><font color="#0000FF">Start</font></b> to go at the first page of results,
    this bloc must countains the variable <b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::start&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;bng.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::start&gt;
</pre>
    </td>
  </tr>
</table>

<ul>
  <li><font color="#0000FF"><b>Previous</b></font> to go at the previous page
    of results, this bloc must countains the variable<b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::previous&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;prev.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::previous&gt;
</pre>
      </td>
  </tr>
</table>
<ul>
  <li><font color="#0000FF"><b>Next</b></font> to go at the next page of results,
    this bloc must countains the variable <b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::next&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;suiv.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::next&gt;
</pre>
    </td>
  </tr>
</table>
<ul>
  <li><font color="#0000FF"><b>End</b></font> to go at the last page of results,
    this bloc must countains the variable <b>{_Url} </b></li>
</ul>
<table width="540" border="1" align="center" cellpadding="3" cellspacing="0">
  <tr>
    <td>
<pre>
&lt;bloc::end&gt;
  &lt;a href=&quot;{_Url}&quot;&gt;&lt;img src=&quot;suiv.gif&quot; border=0&gt;&lt;/a&gt;
&lt;/bloc::end&gt;
</pre>
    </td>
  </tr>
</table>
 </description>

 <example>
 <?php

 include("TPLN/TPLN.php");

 $TPLN = new TPLN;
 $TPLN->Open("template.html");
 $query = "SELECT * FROM my_table";

 $TPLN->DbConnect();
 $TPLN->ShowRecords($query,10);  // 10 results by page
 $TPLN->DbClose();

 $TPLN->Write();

 ?>
 </example>

 <warning lang="fr">
 Depuis TPLN 1.5, cette fonction  changer dans son principe de pagination.
 </warning>

 <warning lang="en">
 Since TPLN 1.5, this function has changed his pagination concept.
 </warning>

 <see>CreateFieldVars SetUrl RewriteUrl SetNavColor</see>

</menu>
*/

class TPLN_DB_Xtra extends TPLN_Error
{

// Xtra
 var $cons_query = array(); // la requete disloke est stocke ici
 var $NavColorFirst; // couleur pour la navigation
 var $NavColorSecond;
 var $url; // contient les variables
 var $url_var; // contient les paramtres de l'url
 var $UrlRgxPatterns; // contient le regex pour formatter les urls
 var $UrlRgxReplace;

// propritaire
 var $NbRecordPerPage; // nombre de rsultats voulues par pages
 var $NbResults; // les rsultats
 var $Count;
 var $T_first; // celui uliser pour dterminer l'Id
 var $First;
 var $Last;
 var $PageNumber;
 var $PageCount;
 var $NavColor;



 // constuction de la requete
 function _SetQuery($query)
 {
  
  // encodage de la requete
 $query = str_replace("\n"," ",$query);
 $query = str_replace("\r"," ",$query); 
  
  
  $this->cons_query["STRING"] = $query;
  // on parcours la requete  l'envers ;-)'
  // limit ?
  if(preg_match("/LIMIT(.*)/mi",$query,$match))
   {
    $this->cons_query["LIMIT"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
   }

  // order by
  if(preg_match("/ORDER BY(.*)/mi",$query,$match))
   {
    $this->cons_query["ORDER BY"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
   }

  // where
  if(preg_match("/WHERE(.*)/mi",$query,$match))
   {
    $this->cons_query["WHERE"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
   }

   // from
  if(!preg_match("/FROM(.*)/mi",$query,$match))
   {$this->_DBError(4);}

    $this->cons_query["FROM"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine


   // select
  if(!preg_match("/SELECT(.*)/mi",$query,$match))
   {$this->_DBError(3);}

    $this->cons_query["SELECT"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
 }

// recr une requete avec les nouveau paramtres de LIMIT ;-)
 function _SetQueryLimit()
 {
  if(empty($this->PageNumber)){$this->PageNumber = 1;}

 
 // calcul du nombre de pages
 if($this->NbRecordPerPage == 0)
 {
    $this->PageCount = 1;
    $this->PageNumber = 1;
    $this->First = 1;
    $this->T_first = $this->First;
    $this->Last = $this->Count;   
 }
 else
 {
    $this->PageCount = ceil($this->Count / $this->NbRecordPerPage); // arrondi a l'entier superieur
    if($this->PageNumber > $this->PageCount){$this->PageNumber = 1;} // erreur


     // on determine debut du limit
     $this->First = ($this->PageNumber - 1) * $this->NbRecordPerPage;
     $this->T_first = $this->First ;
     $this->Last = $this->First + $this->NbRecordPerPage; 
 }


  // on reconstruit la requete
 $query = "SELECT ";
 $query .= $this->cons_query["SELECT"];
 $query .= " FROM ";
 $query .= $this->cons_query["FROM"];

 // Where
 if(!empty($this->cons_query["WHERE"]))
   {$query .= " WHERE ";
    $query .= $this->cons_query["WHERE"];}

 // Order By
 if(!empty($this->cons_query["ORDER BY"]))
   {$query .= " ORDER BY ";
    $query .= $this->cons_query["ORDER BY"];}

 // limit ?
 if($this->NbRecordPerPage > 0)
 {
     $query .= " LIMIT  $this->First,$this->NbRecordPerPage";
     
      //if($this->First == 0){$this->First = 1;}
      $this->First++;
      if($this->Last > $this->Count){$this->Last = $this->Count;}
 }

 return $query;
}

// retourne la bonne url formatte
 function _getUrl($t_pg="")
 {
   $url = $this->Url."tpg=$t_pg".$this->url_var;

   if(!empty($this->UrlRgxPatterns) && !empty($this->UrlRgxReplace))
       $url = @preg_replace('/'.$this->UrlRgxPatterns.'/i',$this->UrlRgxReplace,$url);

   return $url;
 }


/*
<docgeny>
<submenu name="rewriteurl" parent="showrecords">
 <name lang="fr">RewriteUrl</name>
 <name lang="en">RewriteUrl</name>

 <function>void RewriteUrl(string patterns, string replace)</function>

 <description lang="fr">
 La fonction RewriteUrl() sert  reformater les urls gnres par les blocs de la fonctions ShowRecords.
 </description>

 <description lang="en">
 The RewriteUrl() function  serves to reformat the urls generated by the blocks of the ShowRecords functions.
 For more of information: <a href = "http://httpd.apache.org/docs-2.0/misc/rewriteguide.html" target = "_blank">http://httpd.apache.org/docs-2.0/misc/rewriteguide.html </a>
 </description>

 <example>
 <?php

 include("TPLN/TPLN.php");

 $TPLN = new TPLN;
 $TPLN->Open("template.html");
 $query = "SELECT * FROM my_table";

 $TPLN->DbConnect();
 $TPLN->RewriteUrl('test.php','test.html'); // rewrite all url by test .html
 $TPLN->SetNavColor("#CCCCCC","#FFFFFF");
 $TPLN->ShowRecords($query,10);  // 10 results by page
 $TPLN->DbClose();

 $TPLN->Write();

 ?>
 </example>

 <warning lang="fr">
 N'oubliez de backslasher votre caratres sensibles dans votre expression rgulires ! ( ? inclu )
 </warning>

 <warning lang="en">
 Don't forget to backslash your sensitive characters in your regullary expression ! ( ? included )
 </warning>

 <see>ShowRecords</see>

</submenu>
</docgeny>
*/
function RewriteUrl($patterns,$replace)
{
   $this->UrlRgxPatterns = $patterns;
   $this->UrlRgxReplace = $replace;
}


/*
<docgeny>
<submenu name="setnavcolor" parent="showrecords">
 <name lang="fr">SetNavColor</name>
 <name lang="en">SetNavColor</name>

 <function>void SetNavColor( string color1, string color2)</function>

 <description lang="fr">
 La fonction SetNavColor() permet d'alterner les couleurs pour pour l'item <b><font color="#0000FF">{_NavColor}</font></b>.
 </description>

 <description lang="en">
 The SetNavColor() function permits to alternate color for variable <b><font color="#0000FF">{_NavColor}</font></b>.
 </description>

 <example>
 <?php

 include("TPLN/TPLN.php");

 $TPLN = new TPLN;
 $TPLN->Open("template.html");
 $query = "SELECT * FROM my_table";

 $TPLN->DbConnect();
 $TPLN->SetNavColor("#CCCCCC","#FFFFFF");
 $TPLN->ShowRecords($query,10);  // 10 results by page
 $TPLN->DbClose();

 $TPLN->Write();

 ?>
 </example>

</submenu>
</docgeny>
*/
 function SetNavColor($color1,$color2)
 {
   $this->NavColorFirst = $color1;
   $this->NavColorSecond = $color2;
 }

 // prise totale des rsulats
 function _GetTotalCount()
 {
   $query = "SELECT COUNT(*) ";
   $query .= "FROM ";
   $query .= $this->cons_query["FROM"];

   if(!empty($this->cons_query["WHERE"]))
     {
      $query .= " WHERE ";
      $query .= $this->cons_query["WHERE"];
     }

   $this->DoQuery($query);
   $this->Count = $this->GetOne();
   //$this->Count = $this->db[$this->db_index]->getOne($query);
 }


// redefini les variables propriaitaire
 function _ApplyPrivateVar()
 {
   if(empty($this->Url))
    {
      $this->Url = basename($_SERVER['PHP_SELF'])."?";
    }

   // Variable TPLN
   if($this->ItemExists("_Count","data"))
      $this->Parse("data._Count",$this->Count);

   if($this->ItemExists("_First","data"))
      $this->Parse("data._First",$this->First);

   if($this->ItemExists("_Last","data"))
      $this->Parse("data._Last",$this->Last);

   if($this->ItemExists("_PageCount","data"))
      $this->Parse("data._PageCount",$this->PageCount);

   if($this->ItemExists("_PageNumber","data"))
      $this->Parse("data._PageNumber",$this->PageNumber);

   // PREVIOUS
   if($this->BlocExists("previous"))
   {
     if(!$this->ItemExists("_Url","previous"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"previous","_Url");
         return;
     }

     if($this->PageNumber <= $this->PageCount && $this->PageCount != 1 && $this->PageNumber != 1)
     {
        $prev_pg = $this->PageNumber - 1;
        $url = $this->_getUrl($prev_pg);
        $this->Parse("data.previous._Url",$url);
     }
     else
        $this->EraseBloc("data.previous");
   }

   // NEXT
   if($this->BlocExists("next"))
   {
     if(!$this->ItemExists("_Url","next"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"next","_Url");
         return;
     }

     if($this->PageNumber < $this->PageCount && $this->PageCount != 1)
     {
        $next_pg = $this->PageNumber + 1;
        $url = $this->_getUrl($next_pg);
        $this->Parse("data.next._Url",$url);
     }
     else
        $this->EraseBloc("data.next");
   }

   // START
   if($this->BlocExists("start"))
   {
     if(!$this->ItemExists("_Url","start"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"start","_Url");
         return;
     }

     if($this->PageCount > 1)
     {
        $url = $this->_getUrl(1);
        $this->Parse("data.start._Url",$url);
     }
     else
        $this->EraseBloc("data.start");
   }

   // END
   if($this->BlocExists("end"))
   {
     if(!$this->ItemExists("_Url","end"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"end","_Url");
         return;
     }

     if($this->PageCount > 1)
     {
        $url = $this->_getUrl($this->PageCount);
        $this->Parse("data.end._Url",$url);
     }
     else
        $this->EraseBloc("data.end");
   }

   // PAGER
   if($this->BlocExists("pager"))
   {
     // bloc out & in
     if(!$this->BlocExists("out"))
     {
       $this->_Error(2,$this->f["$this->f_no"]["name"],"out");
       return;
     }
     if(!$this->ItemExists("_Url","out"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"out","_Url");
         return;
     }
     if(!$this->ItemExists("_Page","out"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"out","_Page");
         return;
     }

     if(!$this->BlocExists("in"))
     {
       $this->_Error(2,$this->f["$this->f_no"]["name"],"in");
       return;
     }

     if(!$this->ItemExists("_Page","in"))
     {
         $this->_Error('1.1',$this->f["$this->f_no"]["name"],"in","_Page");
         return;
     }

     if($this->PageCount > 1)
     {
       $in = $this->GetBlocInFile("data.pager.in");
       $out = $this->GetBlocInFile("data.pager.out");

       //$this->EraseBloc("in");
       //$this->EraseBloc("out");

       $str = "";

       for($l=1; $l <= $this->PageCount; $l++)
       {
         if($l == $this->PageNumber)
         {
           $str .= str_replace("{_Page}",$l,$in);
         }
         else
         {
           $url = $this->_getUrl($l);

           $tmp = str_replace('{_Page}',$l,$out);
           $tmp = str_replace('{_Url}',$url,$tmp);

           $str .= $tmp;
         }
       }

       $this->ParseBloc("data.pager",$str);
     }
     else
     {
        $this->EraseBloc("data.pager");
     }
   }

    // initialise la navigation
    if(empty($this->NavColorFirst)){$this->NavColorFirst = $GLOBALS['TPLN_DB_NavColorFirst'];}
    if(empty($this->NavColorSecond)){$this->NavColorSecond = $GLOBALS['TPLN_DB_NavColorSecond'];}

 }

/*
<docgeny>
<submenu name="seturl" parent="showrecords">
 <name lang="fr">SetUrl</name>
 <name lang="en">SetUrl</name>

 <function>void SetUrl( string url)</function>

 <description lang="fr">
 La fonction SetUrl() permet de changer les liens des url gnrs par la fonctions <b>ShowRecords()</b>.
 </description>

 <description lang="en">
 SetUrl() permits to change the generated links by <b>ShowRecords()</b> function.
 </description>

 <warning lang="fr">
 Si cette fonction n'est pas utilise TPLN choisi le fichier appel par defaut.
 </warning>

 <warning lang="en">
 If this function is not used the link by default is the php file called.
 </warning>
</submenu>
</docgeny>
*/
 function SetUrl($url)
 {
   $this->Url = $url;
 }

/*
<docgeny>
<submenu name="urladdvar" parent="showrecords">
 <name lang="fr">UrlAddVar</name>
 <name lang="en">UrlAddVar</name>

 <function>void UrlAddVar( string var)</function>

 <description lang="fr">
 La fonction SetUrl() permet d'ajouter une variable dans l'url gnre par la fonction <b>Showrecords()</b>.
 </description>

 <description lang="en">
 the UrlAddVar() functions permits to add variable in the generated url by <b>Showrecords()</b>.
 </description>

 <example>
 <?php

 include("TPLN/TPLN.php");

 $TPLN = new TPLN;
 $TPLN->Open("template.html");

 $TPLN->DbConnect();
 $TPLN->UrlAddVar("var=my_var");
 $TPLN->ShowRecords("SELECT * FROM my_table",10);  // 10 results by page
 $TPLN->DbClose();

 $TPLN->Write();

 ?>
 </example>

 <see>ShowRecords</see>

</submenu>
</docgeny>
*/
 function UrlAddVar($url_add)
 {
  $this->url_var = "&$url_add";
 }


/*
<docgeny>
<submenu name="createfieldvars" parent="showrecords">
 <name lang="fr">CreateFieldVars</name>
 <name lang="en">CreateFieldVars</name>

 <function>void CreateFieldVars( string|Array bloc_path, array fields)</function>

 <description lang="fr">
 La fonction CreateFieldVars() permet de crer les variables au sein du bloc dfini
 contenant le nom de vos champs.
 <br>
 <br>
 Cette fonction utilise le mot clef <b>{_Field}</b> au sein du dernier bloc.<br>
 Cette fonction n'est utilisable que dans un bloc imbriqu.<br>
 Apres l'appel de la fonction, le dernier bloc est effac du template et est remplace par
 les variables contenant le nom des fichiers.
 <br>
 <br>
 Vous pouvez passer un array en paramtre contenant les differents chemin de blocs
 </description>

 <description lang="en">
 the function CreateFieldVars() permits to create variables in a bloc
 containing your field transformed in keyword.
 <br>
 <br>
 This function uses keyword <b>{_Field}</b> in your last bloc. <br>
 Your bloc path must have a parent bloc. <br>
 At end, the last bloc is erased in your template.<br>
 You can path an array containing all bloc path
 </description>

 <example>
 <?php

 include("TPLN/TPLN.php");

 $TPLN = new TPLN;
 $TPLN->Open("template.html");

 $TPLN->DbConnect();
 $TPLN->CreateFieldVars("data.loop.dynam", "SELECT * FROM table LIMIT 1"); // create variables
 $TPLN->ShowRecords("SELECT * FROM table",10);
 $TPLN->DbClose();

 $TPLN->Write();

 ?>
 </example>

 <warning lang="fr">
 Depuis TPLN 1.5
 </warning>

 <warning lang="en">
 Since TPLN 1.5
 </warning>

 <see>ShowRecords ParseDBRow</see>

</submenu>
</docgeny>
*/
function CreateFieldVars($path,$fields)
{
  // chemin dfini en array
  if(is_array($path))
  {
     for($i=0;$i<count($path);$i++)
     {
          $this->CreateFieldVars($path[$i],$fields);
     }
     return;
  }

  $arr = @explode('.',$path);

  if(count($arr) == 1)
  {
     $this->_Error('13',$this->f["$this->f_no"]["name"],$arr[0]);
     return;
  }

  $lastbloc = $arr[count($arr)-1];

  // Verification du mot clefs _Field
  if(!$this->ItemExists('_Field',$lastbloc))
  {
     $this->_Error('1.1',$this->f["$this->f_no"]["name"],$lastbloc,'_Field');
     return;
  }

  $cur_bloc_ini = $this->GetBlocInFile($lastbloc);
  $str = "";
  $all = "";
  $tab = array();


  for($i=0;$i < count($fields);$i++)
  {
      // on remplace le mot clef field
      $str =  str_replace("{_Field}","{".$fields[$i]."}",$cur_bloc_ini);
      $all .= $str;

  }

  // on remplace le contenu du champs
  //$this->ParseBloc($path, $all);
  $this->ParseBloc($lastbloc, $all);

  // on retire le dernier du path
  // on veut que le chemin des peres
  $path = $this->_GetFathers($path,'ARRAY',0);
  $path = array_slice ($path, 0, count($path)-1);
  $path = join($path,'.');

  $this->ReloadBlocVars($path);

}




 function ShowRecords($query,$nb_result_per_page=0)
 {
   // vrification du second paramtre
   if(!is_int($nb_result_per_page))
   {
       $this->_DBError(5);
       return;
   }
   if($nb_result_per_page <  0)
   {
      $this->_DBError('5.1');
      return;
   }

   $this->NbRecordPerPage = $nb_result_per_page;


   if($this->NbRecordPerPage != 0 && isset($_GET["tpg"]))
   {
    $this->PageNumber = $_GET["tpg"]; // variable passe en parametre
   }
   else
   {
    $this->PageNumber = NULL;
   }


   $this->_SetQuery($query); // reconstruit la requete
   $this->_GetTotalCount(); //  nb totl d'enregistrements

   // pas du tout d'enregistrement
   if($this->Count == 0)
    {
     $no_records = $this->GetBlocInFile("data.norecord");
     $this->EraseBloc("data.norecord");
     $this->ParseBloc("data",$no_records);
     return;
    }

   $new_query = $this->_SetQueryLimit(); // requete contenant les limites
   $this->DoQuery($new_query); // execute la requete
   //$results = $this->GetData(); // recupere les rsultats
   $this->NbResults = $this->DbNumRows(); // resultats obtenues != $this->count


   if($this->NbResults == 0)// il y'en a pas pour une recherche
    {
     // a redefinir pour la recherche
     $no_records = $this->GetBlocInFile("data.norecord");
     $this->EraseBloc("data.norecord");
     $this->ParseBloc("data",$no_records);
     return;
    }
   else // si il y a des rsultats alors
    {
      $this->EraseBloc("data.norecord"); // on efface norecord
      $this->_ApplyPrivateVar(); // on modifie les items propriaitaire $Count...
      if(count($this->f[$this->f_no]["shortcut_blocs"]["loop"]["items"]) == 0){ return;}

       // parsing
       $i = 0; // pour la _NavColor
       $T_id = $this->T_first;  // pour _Id
       while($row = $this->DbFetchAssoc())
        {
          $keys = @array_keys($row);// prise du mon des clefs

          // echo "{$row['User']} {$row['Password']}<br>";
          foreach($keys as $key)
           {
                // ajout de la nav color
                if($this->ItemExists("_NavColor","loop"))
                {
                  $color = ($i % 2) ? $this->NavColorFirst  : $this->NavColorSecond;
                  $this->Parse("data.loop._NavColor",$color);
                }

                // ajout de l'Id
                if($this->ItemExists("_Id","loop"))
                  $this->Parse("data.loop._Id",$T_id);

                if($this->ItemExists($key,"loop"))
                   $this->Parse("data.loop.$key",$row["$key"]);
           }
           $i++;
           $T_id++;
           $this->Loop("data.loop");
        }
  }


 }
}



?>