#
# Table structure for table 'component'
#

CREATE TABLE `component` (
  `component_id` int(11) NOT NULL auto_increment,
  `vendor_id` int(11) NOT NULL default '0',
  `partnum` varchar(10) NOT NULL default '',
  `modeltype` varchar(20) NOT NULL default '',
  `cpu_speed` varchar(20) NOT NULL default '',
  `hd_size` varchar(6) NOT NULL default '',
  `comment` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`component_id`)
) TYPE=MyISAM COMMENT='component table';



#
# Dumping data for table 'component'
#

INSERT INTO `component` (`component_id`, `vendor_id`, `partnum`, `modeltype`, `cpu_speed`, `hd_size`, `comment`) VALUES("1", "0", "2346-R7G", "Ibm Thinkpad T30", "Pentium\r\n4 2.0Ghz", "40", "some comment");


#
# Table structure for table 'empty'
#

CREATE TABLE `empty` (
  `id` int(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;



#
# Dumping data for table 'empty'
#



#
# Table structure for table 'news'
#

CREATE TABLE `news` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `date` date default NULL,
  `title_fr` varchar(255) default NULL,
  `title_en` varchar(255) default NULL,
  `text_fr` text,
  `text_en` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`,`date`)
) TYPE=MyISAM;



#
# Dumping data for table 'news'
#

INSERT INTO `news` (`id`, `date`, `title_fr`, `title_en`, `text_fr`, `text_en`) VALUES("1", "2002-12-23", "Nouveau site et sortie de TPLN 1.4 !", "New website and TPLN 1.4 release !", "Ainsi, qu\'un nouveau site pour TPLN et  d\'une nouvelle documentation.\r\n\r\nau programme de la version 1.4<ul>\r\n<li>rewriting entier du code pour une amlioration des performances</li><li>gestions des blocs imbriqus</li><li>support multibases via PEAR (mysql, sybase..)</li><li>support de connection multidomaines</li><li>bugs rsolus</li>\r\n</ul>\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4.zip?download\">[>>] Tlchargement</a>\r\n\r\nBonnes ftes\r\n", "A new website for TPLN as well as a better documentation.  \r\n  \r\nFeatures version 1.4<ul><li>improve code</li>  <li>managements of the blocks overlapped</li>  <li>support multidatabases via PEAR (mysql, sybase..)</li>  <li>support of multi connection</li>  <li>bugs fixed</li></ul>\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4.zip?download\">[>>]  Download</a>\r\n\r\nHappy holidays");
INSERT INTO `news` (`id`, `date`, `title_fr`, `title_en`, `text_fr`, `text_en`) VALUES("2", "2003-01-16", "Sortie de TPLN 1.4 rvision 2 !", "TPLN 1.4 revision 2 released !", "Une nouvelle version de TPLN qui amliore lgrement les performances  en fixant les notices qui apparaissent dans une configuration PHP avec EALL.\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4r2.zip?download\">[>>]  Tlchargement</a>", "TPLN is now compatible with a php configuration when error reporting is EALL.\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4r2.zip?download\">[>>]  Download</a>");
INSERT INTO `news` (`id`, `date`, `title_fr`, `title_en`, `text_fr`, `text_en`) VALUES("3", "2003-02-01", "Sortie de TPLN 1.4 rvision 3 !", "TPLN 1.4 revision 3 released !", "Rglage d\'un mini bug\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4r3.zip?download\">[>>]  Tlchargement</a>", "Erase a minor bug\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4r3.zip?download\">[>>]  Download</a>");
INSERT INTO `news` (`id`, `date`, `title_fr`, `title_en`, `text_fr`, `text_en`) VALUES("4", "2003-04-25", "Sortie de TPLN 1.4 rvision 4 !", "TPLN 1.4 revision 4 released !", "Ajout option de dossier et d\'extension de template par dfaut\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4r4.zip?download\">[>>]  Tlchargement</a>", "Add default folder and extension template option\r\n\r\n<a href=\"http://prdownloads.sourceforge.net/tpln/tpln_v_1_4r4.zip?download\">[>>]  Download</a>");


#
# Table structure for table 'samples'
#

CREATE TABLE `samples` (
  `User` varchar(50) NOT NULL default '',
  `Password` varchar(50) NOT NULL default '',
  KEY `User` (`User`,`Password`)
) TYPE=MyISAM COMMENT='Tables pour les essaies du site';



#
# Dumping data for table 'samples'
#

INSERT INTO `samples` (`User`, `Password`) VALUES("Cinhi", "mop8Pl");
INSERT INTO `samples` (`User`, `Password`) VALUES("Emilem", "5984lm");
INSERT INTO `samples` (`User`, `Password`) VALUES("extract me", "here");
INSERT INTO `samples` (`User`, `Password`) VALUES("garou", "selem");
INSERT INTO `samples` (`User`, `Password`) VALUES("go end", "ok");
INSERT INTO `samples` (`User`, `Password`) VALUES("kioup", "detsr");
INSERT INTO `samples` (`User`, `Password`) VALUES("Laurent H", "00000");
INSERT INTO `samples` (`User`, `Password`) VALUES("mama", "lol");
INSERT INTO `samples` (`User`, `Password`) VALUES("mc", "decon");
INSERT INTO `samples` (`User`, `Password`) VALUES("mikei", "os528");
INSERT INTO `samples` (`User`, `Password`) VALUES("none", "php");
INSERT INTO `samples` (`User`, `Password`) VALUES("paranassa", "tova");
INSERT INTO `samples` (`User`, `Password`) VALUES("popo", "kiu8952");
INSERT INTO `samples` (`User`, `Password`) VALUES("puoik", "pak");
INSERT INTO `samples` (`User`, `Password`) VALUES("sdfs", "82d8d2d");
INSERT INTO `samples` (`User`, `Password`) VALUES("sergi", "ponos5");
INSERT INTO `samples` (`User`, `Password`) VALUES("thanks", "lolo !");
INSERT INTO `samples` (`User`, `Password`) VALUES("tpln", "enjoy !");


#
# Table structure for table 'workstation'
#

CREATE TABLE `workstation` (
  `wk_id` int(11) NOT NULL auto_increment,
  `component_id` int(11) NOT NULL default '0',
  `screen_id` int(11) default NULL,
  `memory` int(5) NOT NULL default '256',
  `lease_id` int(11) NOT NULL default '0',
  `name` varchar(8) NOT NULL default '',
  `serial` varchar(8) NOT NULL default '',
  `mac_address` varchar(8) NOT NULL default '',
  `ip_address` varchar(12) NOT NULL default '',
  `asset_tag` varchar(6) NOT NULL default '',
  `bios_version` varchar(10) NOT NULL default '',
  `net_topology` varchar(20) NOT NULL default 'Ethernet',
  `os` varchar(20) NOT NULL default 'Windows NT',
  `date_in` date NOT NULL default '0000-00-00',
  `date_out` date NOT NULL default '0000-00-00',
  `accessories` varchar(50) NOT NULL default '',
  `location` varchar(50) NOT NULL default 'Luxembourg',
  `account_num` int(10) default NULL,
  `comment` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`wk_id`),
  UNIQUE KEY `name` (`name`,`serial`,`mac_address`)
) TYPE=MyISAM COMMENT='Workstation table';



#
# Dumping data for table 'workstation'
#

INSERT INTO `workstation` (`wk_id`, `component_id`, `screen_id`, `memory`, `lease_id`, `name`, `serial`, `mac_address`, `ip_address`, `asset_tag`, `bios_version`, `net_topology`, `os`, `date_in`, `date_out`, `accessories`, `location`, `account_num`, `comment`) VALUES("1", "0", "0", "256", "0", "RE5159", "KDDG3RK", "", "dhcp", "35678", "", "Ethernet", "Windows XP", "2003-10-05", "0000-00-00", "", "Luxembourg", "0", "");
